@use 'src/style/variables' as v;
@use './weekPlanning' as wp;

$taskBackgroundColor: var(--task-background-color, var(--surface-100));
$taskBackgroundColorSecondary: var(--task-secondary-color, var(--surface-50));

@mixin triangle {
  content: '';
  position: absolute;
  width: 20px;
  height: 100%;
  background-color: $taskBackgroundColor;
  clip-path: polygon(0 0, 0 100%, 100% 50%);
}

@mixin task {
  --minDurationWidth: 100%;

  display: grid;
  grid-template-areas:
    'Title handle'
    'Subtitle handle'
    'start end';
  grid-template-rows: 1fr min-content min-content;
  grid-template-columns: 1fr min-content;
  gap: v.$spacing-4;
  align-items: center;
  padding: v.$spacing-2 v.$spacing-2;
  border-radius: v.$borderRadius;
  background: linear-gradient(
    90deg,
    $taskBackgroundColor 0 var(--minDurationWidth),
    $taskBackgroundColorSecondary var(--minDurationWidth) 100%
  );
  color: var(--task-text-color, inherit);
  box-shadow: 0 1px 2px rgba(0, 0, 0, 0.15);
  cursor: grab;
  transition: opacity 250ms ease-in-out;

  &--hidden {
    opacity: 0;
  }

  &__Title {
    display: inline;
    grid-area: Title;
    align-self: start;
    justify-self: start;
    overflow: hidden;
    max-width: 100%;
    color: inherit;
    font-weight: 600;
    font-size: 0.9rem;
    text-decoration: none;
    text-overflow: ellipsis;
    white-space: nowrap;
  }

  &__Subtitle {
    grid-area: Subtitle;
    overflow: hidden;
    font-style: italic;
    font-size: 0.8rem;
    white-space: nowrap;
  }

  &__StartDate {
    grid-area: start;
    justify-self: start;
    padding: v.$spacing-4/2 v.$spacing-4;
    border-top-right-radius: v.$borderRadius;
    border-bottom-left-radius: v.$borderRadius;
    background-color: $taskBackgroundColor;
    font-size: 0.8rem;
    white-space: nowrap;
  }

  &__EndDate {
    grid-area: end;
    padding: v.$spacing-4/2 v.$spacing-4;
    border-top-left-radius: v.$borderRadius;
    border-bottom-right-radius: v.$borderRadius;
    background-color: $taskBackgroundColor;
    font-size: 0.8rem;
    white-space: nowrap;
  }

  &--endAfter {
    border-top-right-radius: 0;
    border-bottom-right-radius: 0;

    &::after {
      @include triangle;

      right: -20px;
    }
  }

  &--startBefore {
    border-top-left-radius: 0;
    border-bottom-left-radius: 0;

    &::before {
      @include triangle;

      left: -20px;
      transform: rotate(180deg);
    }
  }
}
